﻿'Murmur Admin Console is a tool allowing the player administration of murmur servers
'Copyright (C) 2009  Matthew Minter (matt@masarand.com)

'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Public Class SSHManager

    Private Function Sendcommand(ByVal username As String, ByVal password As String, ByVal serveraddress As String, ByVal serverport As Integer, ByVal commandtosend As String)

        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim datadir As String = mydir & "\data\"
        Dim returnedoutput As String
        Dim totextout As String = "plink -pw " & password & " -ssh " & username & "@" & serveraddress & " -P " & serverport & " " & commandtosend & " >" & """" & datadir & "returnedoutput.txt" & """"
        Dim CommandWritter As System.IO.StreamWriter = My.Computer.FileSystem.OpenTextFileWriter(datadir & "CommandToSend.bat", False, System.Text.Encoding.ASCII())
        Dim RunningShell As Integer
        Dim TempVarForTimeWasting As Integer = 1
        Dim RunningShellProcess As Process
        CommandWritter.Write(totextout)
        CommandWritter.WriteLine()
        CommandWritter.Write("exit")
        CommandWritter.Flush()
        CommandWritter.Close()
        RunningShell = Shell("""" & datadir & "CommandToSend.bat""", AppWinStyle.Hide, False, -1)
        RunningShellProcess = Process.GetProcessById(RunningShell, My.Computer.Name())
        LoadSplash.Show()
        Do Until RunningShellProcess.HasExited()
            LoadSplash.Location = MurmurAdminConsole.Location
            LoadSplash.Refresh()
            LoadSplash.Focus()
            TempVarForTimeWasting = TempVarForTimeWasting + 1
        Loop
        LoadSplash.Close()
        My.Computer.FileSystem.DeleteFile(datadir & "CommandToSend.bat")
        If My.Computer.FileSystem.FileExists(datadir & "returnedoutput.txt") And My.Computer.FileSystem.ReadAllText(datadir & "returnedoutput.txt") <> "" Then
            returnedoutput = My.Computer.FileSystem.ReadAllText(datadir & "returnedoutput.txt")
        Else
            MurmurAdminConsole.CurrentlyConnected = False
            MurmurAdminConsole.ConnectedServer = ""
            MurmurAdminConsole.ConnectedServerAddress = ""
            MurmurAdminConsole.ConnectedServerUserName = ""
            MurmurAdminConsole.ConnectToServer.Enabled = True
            MurmurAdminConsole.PlayerListLabel.Text = "Player List"
            MurmurAdminConsole.PlayerList.Items.Clear()
            MurmurAdminConsole.EditPlayerEmailBox.Text = ""
            MurmurAdminConsole.EditPlayerNameBox.Text = ""
            MurmurAdminConsole.EditPlayerPasswordBox.Text = ""

            ConnectToAServer.ShowDialog()
            Return ""
            Exit Function
        End If

        Return returnedoutput
    End Function

    Public Function GetPlayerList(ByVal username As String, ByVal password As String, ByVal serveraddress As String, ByVal serverport As Integer)
        Dim BaseCommandToSend As String = "dbus-send --" + MurmurAdminConsole.ServerBusBox.Text + " --print-reply --dest=net.sourceforge.mumble.murmur --type=method_call /" + MurmurAdminConsole.VserverNumber.Value.ToString + " net.sourceforge.mumble.Murmur.getPlayerNames array:int32:"
        Dim mydir As String = My.Computer.FileSystem.CurrentDirectory
        Dim IDsString As String = ""
        Dim IDSet As Integer = 0
        Dim EmptyArray(0 To 0) As String
        EmptyArray(0) = ""
        Dim PlayerList(0 To 0) As String
        Dim ReturnFromCommand As String

        While 1 = 1
            For IDsToAdd As Integer = 0 To 99
                IDsString = IDsString & (IDsToAdd + IDSet * 100) & ","
            Next
            ReturnFromCommand = Sendcommand(username, password, serveraddress, serverport, BaseCommandToSend & IDsString)
            If ReturnFromCommand = "" Then
                Return EmptyArray
                Exit Function
            End If
            If ReturnFromCommand.Contains(My.Computer.FileSystem.ReadAllText(mydir & "\emptyoutputpart.txt")) Then
                ReDim Preserve PlayerList(0 To PlayerList.Length - 2)
                Return PlayerList
                Exit Function
            End If
            ReturnFromCommand = ReturnFromCommand.Replace(" string ", "")
            ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf(""""))

            While ReturnFromCommand.Contains("""")
                ReturnFromCommand = ReturnFromCommand.Remove(0, 1)
                If ReturnFromCommand.IndexOf("""") <> 0 Then
                    PlayerList(PlayerList.Length - 1) = ReturnFromCommand.Substring(0, ReturnFromCommand.IndexOf(""""))
                    ReDim Preserve PlayerList(0 To PlayerList.Length)
                End If
                If ReturnFromCommand.Contains("""") Then
                    ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf("""") + 1)
                    If ReturnFromCommand.Contains("""") Then
                        ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf(""""))
                    End If
                End If
            End While
            IDSet = IDSet + 1
        End While
    End Function

    Public Function CreatePlayer(ByVal username As String, ByVal password As String, ByVal serveraddress As String, ByVal serverport As Integer, ByVal NewPlayersUsername As String, ByVal NewPlayersEmail As String, ByVal NewPlayersPassword As String)
        Dim CreationCommandToSend As String = "dbus-send --" + MurmurAdminConsole.ServerBusBox.Text + " --print-reply --dest=net.sourceforge.mumble.murmur --type=method_call /" + MurmurAdminConsole.VserverNumber.Value.ToString + " net.sourceforge.mumble.Murmur.registerPlayer string:" & NewPlayersUsername
        Dim CommandReturn As String = Sendcommand(username, password, serveraddress, serverport, CreationCommandToSend)
        If CommandReturn = "" Then
            Return -1
            Exit Function
        End If
        Dim PositionOfIndex As Integer = CommandReturn.IndexOf("int32")
        CommandReturn = CommandReturn.Remove(0, PositionOfIndex + 6)
        Dim NewPlayerID As Integer = Convert.ToInt32(CommandReturn)
        Dim EditCommandToSend As String = "dbus-send --" + MurmurAdminConsole.ServerBusBox.Text + " --print-reply --dest=net.sourceforge.mumble.murmur --type=method_call /" + MurmurAdminConsole.VserverNumber.Value.ToString + " net.sourceforge.mumble.Murmur.setRegistration int32:" & NewPlayerID & " string:" & NewPlayersUsername & " string:" & NewPlayersEmail & " string:" & NewPlayersPassword
        Sendcommand(username, password, serveraddress, serverport, EditCommandToSend)
        Return NewPlayerID
    End Function

    Public Function UsernameToInfo(ByVal username As String, ByVal password As String, ByVal serveraddress As String, ByVal serverport As Integer, ByVal PlayerUserName As String, ByVal WantedItem As Integer)
        Dim PlayerInfo(0 To 3) As String
        Dim QueryCommandToSend As String = "dbus-send --" + MurmurAdminConsole.ServerBusBox.Text + " --print-reply --dest=net.sourceforge.mumble.murmur --type=method_call /" + MurmurAdminConsole.VserverNumber.Value.ToString + " net.sourceforge.mumble.Murmur.getRegisteredPlayers string:" & PlayerUserName
        Dim ReturnFromCommand As String = Sendcommand(username, password, serveraddress, serverport, QueryCommandToSend)
        If ReturnFromCommand = "" Then
            Return ""
            Exit Function
        End If
        ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf("int32 ") + 6)
        PlayerInfo(0) = ReturnFromCommand.Substring(0, ReturnFromCommand.IndexOf("string ")).Replace(" ", "")
        ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf("string ") + 8)
        PlayerInfo(1) = ReturnFromCommand.Substring(0, ReturnFromCommand.IndexOf(""""))
        ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf("string ") + 8)
        PlayerInfo(2) = ReturnFromCommand.Substring(0, ReturnFromCommand.IndexOf(""""))
        ReturnFromCommand = ReturnFromCommand.Remove(0, ReturnFromCommand.IndexOf("string ") + 8)
        PlayerInfo(3) = ReturnFromCommand.Substring(0, ReturnFromCommand.IndexOf(""""))
        Return PlayerInfo(WantedItem)
    End Function

    Public Sub EditPlayer(ByVal username As String, ByVal password As String, ByVal serveraddress As String, ByVal serverport As Integer, ByVal PlayerID As Integer, ByVal NewUsername As String, ByVal NewEmail As String, ByVal NewPassword As String)
        Dim EditCommandToSend As String = "dbus-send --" + MurmurAdminConsole.ServerBusBox.Text + " --print-reply --dest=net.sourceforge.mumble.murmur --type=method_call /" + MurmurAdminConsole.VserverNumber.Value.ToString + " net.sourceforge.mumble.Murmur.setRegistration int32:" & PlayerID & " string:" & NewUsername & " string:" & NewEmail & " string:" & NewPassword
        Sendcommand(username, password, serveraddress, serverport, EditCommandToSend)
    End Sub

    Public Sub DeletePlayer(ByVal username As String, ByVal password As String, ByVal serveraddress As String, ByVal serverport As Integer, ByVal PlayerID As Integer)
        Dim DeletionCommandToSend As String = "dbus-send --" + MurmurAdminConsole.ServerBusBox.Text + " --print-reply --dest=net.sourceforge.mumble.murmur --type=method_call /" + MurmurAdminConsole.VserverNumber.Value.ToString + " net.sourceforge.mumble.Murmur.unregisterPlayer int32:" & PlayerID.ToString
        Sendcommand(username, password, serveraddress, serverport, DeletionCommandToSend)
    End Sub

End Class
